#include "satrotor.h"
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#define _GNU_SOURCE
#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>
#include <linux/i2c-dev.h> // I2C bus definitions
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/ioctl.h>

// PTT 0=RX 1=TX
int read_ptt() 
{

#define ADWANDELFAKTOR 4.096/32767.0
#define SPANNUNGSTEILER (7500.0+3600.0)/3600.0

  static int ret=1;
  double faktor = 1.0;
  char buffer[100];

  int ADS_address = 0x48;	// Address of our device on the I2C bus
  int I2CFile;
  
  uint8_t writeBuf[3];		// Buffer to store the 3 bytes that we write to the I2C device
  uint8_t readBuf[2];		// 2 byte buffer to store the data read from the I2C device
  
  int16_t val;				// Stores the 16 bit value of our ADC conversion
  
  I2CFile = open("/dev/i2c-1", O_RDWR);		// Open the I2C device
  flock( I2CFile, LOCK_EX);
  
  ioctl(I2CFile, I2C_SLAVE, ADS_address);   // Specify the address of the I2C Slave to communicate with

//AD-Kanal 1


  // These three bytes are written to the ADS1115 to set the config register and start a conversion
  writeBuf[0] = 1;              // This sets the pointer register so that the following two bytes write to the config register
  writeBuf[1] = 0b11010011;     // This sets the 8 MSBs of the config register (bits 15-8) to 11000011
  writeBuf[2] = 0b11100011;     // This sets the 8 LSBs of the config register (bits 7-0) to 00000011

  // Initialize the buffer used to read data from the ADS1115 to 0
  readBuf[0]= 0;
  readBuf[1]= 0;

  // Write writeBuf to the ADS1115, the 3 specifies the number of bytes we are writing,
  // this begins a single conversion
  write(I2CFile, writeBuf, 3);

  // Wait for the conversion to complete, this requires bit 15 to change from 0->1
  while ((readBuf[0] & 0x80) == 0)      // readBuf[0] contains 8 MSBs of config register, AND with 10000000 to select bit 15
  {
          read(I2CFile, readBuf, 2);    // Read the config register into readBuf
  }

  writeBuf[0] = 0;                                      // Set pointer register to 0 to read from the conversion register
  write(I2CFile, writeBuf, 1);

  read(I2CFile, readBuf, 2);            // Read the contents of the conversion register into readBuf

  val = readBuf[0] << 8 | readBuf[1];   // Combine the two bytes of readBuf into a single 16 bit result

  //printf("PTT %f (V)   \n", (float)val*ADWANDELFAKTOR);        // Print the result to terminal, first convert from binary value to mV

  if( (float)val*ADWANDELFAKTOR < 0.5) ret = 1;
  else if( (float)val*ADWANDELFAKTOR > 1.76) ret=0; 
       else  ret=0;

  flock( I2CFile, LOCK_UN);	
  close(I2CFile);
  
  return(ret);
}

int main (void)
{
  char buffer[200];
  int pol = -1;
  int i;
  int x;

  const struct timespec waittime = { 0, 200000000L };


  printf( "Content-type: text/html\n\n");
  fflush(stdout);

  if( getenv("REQUEST_METHOD") != NULL && !strcmp( "GET", getenv("REQUEST_METHOD"))) {
     if( getenv("QUERY_STRING") != NULL) {
       strcpy( buffer, getenv("QUERY_STRING"));
       if( strstr( buffer, "pol=")) {
         sscanf( buffer, "pol=%d", &pol);
       }
     }
   }

  if( pol < 0) { 
    printf( "Keine Polarisation angegeben\n");
    exit(1); 
  }

  wiringPiSetup () ;
 
  //
  pinMode(HUBM8, OUTPUT);
  pinMode(HUBM7, OUTPUT);
  pinMode(HUBM6, OUTPUT);
  pinMode(HUBM5, OUTPUT);
  pinMode(HUBM4, OUTPUT);
  pinMode(HUBM3, OUTPUT);
  pinMode(HUBM2, OUTPUT);
  pinMode(HUBM1, OUTPUT);
  //
  pinMode(VV2, OUTPUT);
  pinMode(VV70, OUTPUT);
  pinMode(VV23, OUTPUT);
  pinMode(RESET, OUTPUT);
  pinMode(POL1, OUTPUT);
  pinMode(POL2, OUTPUT);
  pinMode(POL3, OUTPUT);
  pinMode(POL4, OUTPUT);
  //
  pinMode(RESET1, OUTPUT);
  pinMode(RESET2, OUTPUT);
  pinMode(ALARM1, OUTPUT);
  pinMode(ALARM2, OUTPUT);
  pinMode(PTT1, OUTPUT);
  pinMode(PTT2, OUTPUT);
  pinMode(POWER1, OUTPUT);
  pinMode(POWER2, OUTPUT);
  //
 
  //Falls PTT aktiv nicht tun
  if( read_ptt()) return 0;
 
  switch( pol) {
    case 0:  //H
             digitalWrite(POL1, LOW);
             digitalWrite(POL2, LOW);
             digitalWrite(POL3, LOW);
             digitalWrite(POL4, LOW);
             break; 
    case 1:  //V
             digitalWrite(POL1, HIGH);
             digitalWrite(POL2, LOW);
             digitalWrite(POL3, LOW);
             digitalWrite(POL4, LOW);
             break;
    case 2:  //R
             digitalWrite(POL1, LOW);
             digitalWrite(POL2, HIGH);
             digitalWrite(POL3, LOW);
             digitalWrite(POL4, LOW);
             break;
    case 3:  //L
             digitalWrite(POL1, HIGH);
             digitalWrite(POL2, HIGH);
             digitalWrite(POL3, LOW);
             digitalWrite(POL4, LOW);
             break;
    default:
             break;
  }
 
  return 0 ;
}

